'
' PCL4PB.BI
'
' PCL4PB functions (for PowerBasic)
'
 DECLARE FUNCTION SioBaud(BYVAL Port AS INTEGER,BYVAL BaudCode AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioBrkKey() AS INTEGER
 DECLARE FUNCTION SioBrkSig(BYVAL Port AS INTEGER,BYVAL Char AS WORD) AS INTEGER
 DECLARE FUNCTION SioCTS(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioDCD(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioDSR(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioDTR(BYVAL Port AS INTEGER,BYVAL Cmd AS WORD) AS INTEGER
 DECLARE FUNCTION SioDelay(BYVAL Tics AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioDone(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioError(BYVAL Code AS Integer) AS INTEGER
 DECLARE FUNCTION SioFIFO(BYVAL Port AS INTEGER,BYVAL Code AS Integer) AS INTEGER
 DECLARE FUNCTION SioFlow(BYVAL Port AS INTEGER,BYVAL Code AS Integer) AS INTEGER
 DECLARE FUNCTION SioGetDiv(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioGetc(BYVAL Port AS INTEGER,BYVAL Tics AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioInfo(BYVAL Char AS WORD) AS INTEGER
 DECLARE FUNCTION SioIRQ(BYVAL Port AS INTEGER,BYVAL IRQ AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioLine(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioLoopBack(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioModem(BYVAL Port AS INTEGER,BYVAL Char AS WORD) AS INTEGER
 DECLARE FUNCTION SioParms(BYVAL Port AS INTEGER,BYVAL Code1 AS Integer,BYVAL Code2 AS Integer,BYVAL Code3 AS Integer) AS INTEGER
 DECLARE FUNCTION SioPorts(BYVAL Port AS INTEGER,BYVAL Code1 AS Integer,BYVAL Code2 AS Integer,BYVAL Code3 AS Integer) AS INTEGER
 DECLARE FUNCTION SioPutc(BYVAL Port AS INTEGER,BYVAL Char AS WORD) AS INTEGER
 DECLARE FUNCTION SioRead(BYVAL Port AS INTEGER,BYVAL Code AS Integer) AS INTEGER
 DECLARE FUNCTION SioReset(BYVAL Port AS INTEGER,BYVAL BaudCode AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioRI(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioRTS(BYVAL Port AS INTEGER,BYVAL Cmd AS WORD) AS INTEGER
 DECLARE FUNCTION SioRxBuf(BYVAL Port AS INTEGER,BYVAL PtrSeg AS WORD,BYVAL Size AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioRxFlush(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioRxQue(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioTimer() AS LONG
 DECLARE FUNCTION SioTxBuf(BYVAL Port AS INTEGER,BYVAL PtrSeg AS WORD,BYVAL Size AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioTxFlush(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioTxQue(BYVAL Port AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioUART(BYVAL Port AS INTEGER,BYVAL UART AS INTEGER) AS INTEGER
 DECLARE FUNCTION SioUnGetc(BYVAL Port AS INTEGER,BYVAL TheChar AS WORD) AS INTEGER

' COM port codes

 %COM1 = 0
 %COM2 = 1
 %COM3 = 2
 %COM4 = 3
 %COM5 = 4
 %COM6 = 5
 %COM7 = 6
 %COM8 = 7
 %COM9 = 8
 %COM10 = 9
 %COM11 = 10
 %COM12 = 11
 %COM13 = 12
 %COM14 = 13
 %COM15 = 14
 %COM16 = 15
 %COM17 = 16
 %COM18 = 17
 %COM19 = 18
 %COM20 = 19



' Baud codes

 %Baud300 = 0
 %Baud600 = 1
 %Baud1200 = 2
 %Baud2400 = 3
 %Baud4800 = 4
 %Baud9600 = 5
 %Baud19200 = 6
 %Baud38400 = 7
 %Baud57600 = 8
 %Baud115200 = 9
 %NORESET = -1

' Parity Codes

%NoParity  = 0
%OddParity  = 1
%EvenParity = 3
%MarkParity = 5
%SpaceParity = 7

' Stop Bit Codes

%OneStopBit  = 0
%TwoStopBits = 1

' Word Length Codes

%WordLength5  = 0
%WordLength6  = 1
%WordLength7  = 2
%WordLength8  = 3

' Buffer Size Codes

%Size128  = 4
%Size256  = 5
%Size512  = 6
%Size1K   = 7
%Size2K   = 8
%Size4K   = 9
%Size8K   = 10
%Size16K  = 11
%Size32K  = 12

' Line Status Masks

%TransBufferEmpty = 32
%BreakDetect  = 16
%FramingError = 8
%ParityError  = 4
%OverrunError = 2
%DataReady    = 1

' Modem Status Masks

%DCD = 128
%RI  =  64
%DSR =  32
%CTS =  16
%DeltaDCD = 8
%DeltaRI  = 4
%DeltaDSR = 2
%DeltaCTS = 1

' SioDTR & SioRTS Commands

%SET.LINE   = 83
%CLEAR.LINE = 67
%READ.LINE  = 82

' Break Signal Commands

%ASSERT.BREAK = 65
%DETECT.BREAK = 68
%CANCEL.BREAK = 67

' FIFO level codes

%FIFO.OFF = -1
%LEVEL.1  =  0
%LEVEL.4  =  1
%LEVEL.8  =  2
%LEVEL.14 =  3

' IRQ codes

%IRQ2 = 2
%IRQ3 = 3
%IRQ4 = 4
%IRQ5 = 5
%IRQ6 = 6
%IRQ7 = 7
%IRQ8 = 8
%IRQ9 = 9
%IRQ10 = 10
%IRQ11 = 11
%IRQ12 = 12
%IRQ13 = 13
%IRQ14 = 14
%IRQ15 = 15

' SioInfo Commands

%VERSION = 86

' SioPort dumbcard types

%PC.PORTS  = 0
%DIGIBOARD = 1
%BOCABOARD = 2
